#############################################################################
#
# This file is part of DistAIX DBconnector
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#############################################################################

CC = g++
TARGETLIB = ../libdatabase-interface.so
CCFLAGS = -std=c++11 -I../include -I./proto -Wall -I/usr/include/postgresql/
LDFLAGS = -L../ -ldatabase-interface -lpq -lcassandra -lprotobuf
SRCFILES = main.cpp proto/message.pb.cc

all: example 

example: lib protobuf main.cpp
	$(CC) $(CCFLAGS) -o example $(SRCFILES) $(LDFLAGS) 

lib: $(TARGETLIB)

protobuf: proto/message.pb.h

proto/message.pb.h: message.proto
	mkdir -p proto
	LD_LIBRARY_PATH=/usr/local/lib/ protoc -I=$(PWD) --cpp_out=$(PWD)/proto message.proto 

$(TARGETLIB):
	cd .. && $(MAKE)

clean:
	rm -rf example proto

.PHONY: clean protobuf lib all